//
// officegen: List of MS-Office field types.
//
// Please refer to README.md for this module's documentations.
//
// Copyright {c} 2013;
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//

module.exports = {
  // presentation slide number:
  SLIDE_NUM: 'slidenum',

  // default date time format for the rendering application:
  DATE_TIME: 'datetime',

  // MM/DD/YYYY date time format (Example: 10/12/2007):
  DATE_MM_DD_YYYY: 'datetime1',

  // Day, Month DD, YYYY date time format (Example: Friday, October 12, 2007):
  DATE_WD_MN_DD_YYYY: 'datetime2',

  // DD Month YYYY date time format (Example: 12 October 2007):
  DATE_DD_MN_YYYY: 'datetime3',

  // Month DD, YYYY date time format (Example: October 12, 2007):
  DATE_MN_DD_YYYY: 'datetime4',

  // DD-Mon-YY date time format (Example: 12-Oct-07):
  DATE_DD_SMN_YY: 'datetime5',

  // Month YY date time format (Example: October 07):
  DATE_MM_YY: 'datetime6',

  // Mon-YY date time format (Example: Oct-07):
  DATE_SMN_YY: 'datetime7',

  // MM/DD/YYYY hh:mm AM/PM date time format (Example: 10/12/2007 4:28 PM):
  DATE_TIME_DD_MM_YYYY_HH_MM_PM: 'datetime8',

  // MM/DD/YYYY hh:mm:ss AM/PM date time format (Example: 10/12/2007 4:28:34 PM):
  DATE_TIME_DD_MM_YYYY_HH_MM_SC_PM: 'datetime9',

  // hh:mm date time format (Example: 16:28):
  TIME_HH_MM: 'datetime10',

  // hh:mm:ss date time format (Example: 16:28:34):
  TIME_HH_MM_SC: 'datetime11',

  // hh:mm AM/PM date time format (Example: 4:28 PM):
  TIME_HH_MM_PM: 'datetime12',

  // hh:mm:ss: AM/PM date time format (Example: 4:28:34 PM):
  TIME_HH_MM_SC_PM: 'datetime13'
}
